package cn.efunbox.controller;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.view.json.MappingJacksonJsonView;

import cn.efunbox.base.Sex;
import cn.efunbox.model.Click;
import cn.efunbox.model.Film;
import cn.efunbox.model.Recommend;
import cn.efunbox.service.IClickService;
import cn.efunbox.service.IFilmService;
import cn.efunbox.service.IRecommendService;

@SuppressWarnings("deprecation")
@Controller
@RequestMapping("/click")
public class ClickController {
	 
	@Autowired  
	private  HttpServletRequest request;
	
	@Autowired
	private IFilmService filmService;
	@Autowired
	private IRecommendService recmdService;
	
    private IClickService clickService;
    
    public IClickService getClickService() {
        return clickService;
    }

    @Autowired
    public void setClickService(IClickService clickService) {
        this.clickService = clickService;
    }

    @RequestMapping("/getAll")
    @ResponseBody
    public Map<String,Object> getAll(){
        List<Click> rows = clickService.loadAll();
        Map<String, Object> map = new HashMap<String, Object>(2);
        map.put("code", 200);
        map.put("rows", rows);
        return map;
    }

    @RequestMapping("/add")
    @ResponseBody
    public Map<String,Object> add(){
    	Map<String, Object> map = new HashMap<String, Object>(2);
        String age = request.getParameter("age")==null?"0":request.getParameter("age").trim();
		String sex = request.getParameter("sex")==null?Sex.BOY.toString():request.getParameter("sex").trim();
		String type = request.getParameter("type")==null?"1":request.getParameter("type").trim();
		String film_code = request.getParameter("film_code")==null?"":request.getParameter("film_code").trim();
		if(film_code.isEmpty()){
			map.put("code", 301);
			map.put("msg", "film_code参数错误");
			return map;
		}
		int curTime = (int)(System.currentTimeMillis()/1000);		
		Click click = new Click();
		click.setAge(Integer.valueOf(age));
		click.setSex(Integer.valueOf(sex));
		click.setType(Integer.valueOf(type));
		click.setFilm_code(film_code);
		click.setCreated(curTime);
/*		
		String film_type = request.getParameter("film_type")==null?"1":request.getParameter("film_type").trim();
		String mark_type = request.getParameter("mark_type")==null?"0":request.getParameter("mark_type").trim();
		String is_vip = request.getParameter("is_vip")==null?"0":request.getParameter("is_vip").trim();
		String film_grade = request.getParameter("film_grade")==null?"5":request.getParameter("film_grade").trim();
		String film_star = request.getParameter("film_star")==null?"5":request.getParameter("film_star").trim();
		String age_group = request.getParameter("age_group")==null?"0":request.getParameter("age_group").trim();
		String series_count = request.getParameter("series_count")==null?"1":request.getParameter("series_count").trim();
		String publish_date = request.getParameter("publish_date")==null?"0":request.getParameter("publish_date").trim();
		String online_date = request.getParameter("online_date")==null?"0":request.getParameter("online_date").trim();
		String area = request.getParameter("area")==null?"0":request.getParameter("area").trim();
		String movie_type = request.getParameter("movie_type")==null?"0":request.getParameter("movie_type").trim();
		String target_people = request.getParameter("target_people")==null?"0":request.getParameter("target_people").trim();
		String language = request.getParameter("language")==null?"0":request.getParameter("language").trim();
		String duration = request.getParameter("duration")==null?"0":request.getParameter("duration").trim();
		click.setAge_group(Integer.valueOf(age_group));
		click.setArea(Integer.valueOf(area));
		click.setDuration(Integer.valueOf(duration));
		click.setFilm_grade(Float.valueOf(film_grade));
		click.setFilm_star(Float.valueOf(film_star));
		click.setFilm_type(Integer.valueOf(film_type));
		click.setIs_vip(Integer.valueOf(is_vip));
		click.setLanguage(Integer.valueOf(language));
		click.setMark_type(Integer.valueOf(mark_type));
		click.setMovie_type(Integer.valueOf(movie_type));
		click.setOnline_date(Integer.valueOf(online_date));
		click.setPublish_date(Integer.valueOf(publish_date));
		click.setSeries_count(Integer.valueOf(series_count));
		click.setTarget_people(Integer.valueOf(target_people));
*/
		Film film = filmService.get(film_code, Integer.valueOf(type));
		if(film==null){
			map.put("code", 302);
			map.put("msg", "film_code或type参数错误，节目不存在");
			return map;
		}
		click.setAge_group(film.getAge_group());
		click.setArea(film.getArea());
		click.setDuration(film.getDuration());
		click.setFilm_grade(film.getFilm_grade());
		click.setFilm_star(film.getFilm_star());
		click.setFilm_type(film.getFilm_type());
		click.setIs_vip(film.getIs_vip());
		click.setLanguage(film.getLanguage());
		click.setMark_type(film.getMark_type());
		click.setMovie_type(film.getMovie_type());
		click.setOnline_date(film.getOnline_date());
		click.setPublish_date(film.getPublish_date());
		click.setSeries_count(film.getSeries_count());
		click.setTarget_people(film.getTarget_people());
		
		int ret = clickService.insert(click);

		Recommend recmd = recmdService.get(Integer.valueOf(age), Integer.valueOf(sex), Integer.valueOf(type), film_code);
		if(recmd!=null){
			recmdService.updateScore(recmd.getId(), recmd.getScore()+10, curTime);
		}
		
		map.put("code", 200);
        map.put("rows", ret);
        return map;
    }
    
}