package cn.efunbox.dao;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import cn.efunbox.model.Film;
import cn.efunbox.model.Recommend;

public interface RecommendMapper {
    /** 
     * 插入一条记录
     * @param person
     */
    int insert(Recommend recmd);
    
    /**
     * 查询所有
     * @return
     */
    List<Recommend> queryAll();

    /**
     * 搜索
     * @return
     */
	List<Map> search(@Param("age") int age, @Param("sex") int sex, @Param("type") int type, @Param("limit") int limit, @Param("offset") int offset);

    /**
     * 搜索单个
     * @return
     */
	Recommend get(@Param("age") int age, @Param("sex") int sex, @Param("type") int type, @Param("film_code") String film_code);

    /**
     * 删除推荐结果
     * @return
     */
	int delete(@Param("type") int type, @Param("film_code") String film_code, @Param("age") int age, @Param("sex") int sex);
	
    /**
     * 更新一条记录的排序积分
     * @param 
     */
	int updateScore(@Param("id") int id, @Param("score") int score, @Param("updated") int updated);

    /**
     * 减半重置记录的排序积分
     * @param 
     */
    int updateScoreAll(@Param("reseted") int reseted);
    
}