package cn.efunbox.service;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import cn.efunbox.model.Recommend;;

public interface IRecommendService {
	/** 
     * 插入一条记录
     * @param person
     */
    int insert(Recommend recmd);
    
    /**
     * 加载全部
     * @return
     */
    List<Recommend> loadAll();

    /**
     * 搜索特定年龄、性别的推荐节目
     * @return
     */
    List<Map> search(int age, int sex, int type, int limit, int offset);

    /**
     * 搜索单个推荐节目
     * @return
     */
    Recommend get(int age, int sex, int type, String film_code);

    /**
     * 删除推荐结果
     * @return
     */
	int delete(int type, String film_code, int age, int sex);
	
    /**
     * 更新一条记录的排序积分
     * @param 
     */
    int updateScore(int id, int score, int updated);

    /**
     * 减半重置记录的排序积分
     * @param 
     */
    int updateScoreAll();
    
}