package cn.efunbox.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.efunbox.model.Recommend;
import cn.efunbox.dao.RecommendMapper;
import cn.efunbox.service.IRecommendService;;;

@Service("recommendService")
public class RecommendServiceImpl implements IRecommendService {
    	
    private RecommendMapper recmdMapper;

    public RecommendMapper getRecommendMapper() {
        return recmdMapper;
    }
    
    @Autowired
    public void setRecommendMapper(RecommendMapper recmdMapper) {
        this.recmdMapper = recmdMapper;
    }

	public int insert(Recommend recmd) {
		// TODO Auto-generated method stub
		return recmdMapper.insert(recmd);
	}
    
	public List<Recommend> loadAll() {
		// TODO Auto-generated method stub
		return recmdMapper.queryAll();
	}

	public List<Map> search(int age, int sex, int type, int limit, int offset) {
		// TODO Auto-generated method stub
		return recmdMapper.search(age, sex, type, limit, offset);
	}

	public Recommend get(int age, int sex, int type, String film_code) {
		// TODO Auto-generated method stub
		return recmdMapper.get(age, sex, type, film_code);
	}

	public int delete(int type, String film_code, int age, int sex) {
		// TODO Auto-generated method stub
		return recmdMapper.delete(type, film_code, age, sex);
	}

    /**
     * 更新一条记录的排序积分
     * @param 
     */
	public int updateScore(int id, int score, int updated){
		return recmdMapper.updateScore(id, score, updated);
	}

    /**
     * 减半重置记录的排序积分
     * @param 
     */
	public int updateScoreAll(){
		int curTime = (int)(System.currentTimeMillis()/1000);
		return recmdMapper.updateScoreAll(curTime);
	}

}